//=============================================================================
// ChoiceCrisis.js
//=============================================================================
/*:
 * @plugindesc ChoiceCrisis専用プラグイン
 * @author kotonoha*
 * @help ChoiceCrisisのゲーム専用プラグインです。
 * 二次利用および再配布禁止
 * 
 */

(function() {

	// アニメーションレートを変更
	Sprite_Animation.prototype.setupRate = function() {
		this._rate = 3;
	};

	// デフォルト文字サイズ
	Window_Base.prototype.standardFontSize = function() {
	    return 22;
	};

	// 会話ウィンドウの文字サイズ
	Window_Message.prototype.standardFontSize = function() {
	    return 28;
	};
	Window_MenuStatus.prototype.standardFontSize = function() {
	    return 28;
	};
	Window_BattleStatus.prototype.standardFontSize = function() {
	    return 28;
	};

	// ウィンドウ行数
	Window_Message.prototype.numVisibleRows = function() {
	    return 3;
	};
	
	// スイッチ1で行数変更
	Window_Message.prototype.updatePlacement = function() {
	    this._positionType = $gameMessage.positionType();
		if ($gameParty.inBattle() && $gameSwitches.value(1) === true) {
		this.y = this._positionType * (Graphics.boxHeight - this.height) / 2 + 60;
	    }else{
		this.y = this._positionType * (Graphics.boxHeight - this.height) / 2;
	    }
	    this._goldWindow.y = this.y > 0 ? 0 : Graphics.boxHeight - this._goldWindow.height;
	};

	// バトルウィンドウ
	Window_BattleStatus.prototype.initialize = function() {
//	    var width = this.windowWidth();
		var width = 400;
//	    var height = this.windowHeight();
	    var height = 160;
	    var x = Graphics.boxWidth - width;
	    var y = Graphics.boxHeight / 2;
	    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
	    this.refresh();
	    this.openness = 0;
		if ($gameSwitches.value(147) === true) {
			this.setBackgroundType(1);
		}else{
			this.setBackgroundType(-1);
		}
	};

	// 表示行数
	Window_BattleStatus.prototype.numVisibleRows = function() {
	    return 4;
	};

	// ウィンドウ幅
	Window_BattleStatus.prototype.windowWidth = function() {
	    return 400;
	};
	
	// 通常領域の矩形
	Window_BattleStatus.prototype.basicAreaRect = function(index) {
		var rect = this.itemRectForText(index);
		rect.width = Window_Base._iconWidth * 4;
		rect.x = this.contents.width - rect.width;
		return rect;
	};

	// ゲージ領域の矩形
	Window_BattleStatus.prototype.gaugeAreaRect = function(index) {
		var rect = this.itemRectForText(index);
		rect.width = Window_Base._iconWidth * 4;
		rect.x = this.contents.width - rect.width;
		return rect;
	};
	
	// 通常領域の描画
	Window_BattleStatus.prototype.drawBasicArea = function(rect, actor) {
	    this.drawActorIcons(actor, rect.x, rect.y + this.lineHeight() * 2.5, rect.width);
	//    this.drawActorName(actor, rect.x + 0, rect.y, 150);
	//    this.drawActorIcons(actor, rect.x + 156, rect.y, rect.width - 156);
	};

	// TPありでのゲージ領域の描画
	Window_BattleStatus.prototype.drawGaugeAreaWithTp = function(rect, actor) {
	    this.drawActorHp(actor, rect.x, rect.y, rect.width);
	    //this.drawActorMp(actor, rect.x + 123, rect.y, 96);
	    this.drawActorTp(actor, rect.x, rect.y + this.lineHeight(), rect.width);
	};

	// TPなしでのゲージ領域の描画
	Window_BattleStatus.prototype.drawGaugeAreaWithoutTp = function(rect, actor) {
	    this.drawActorHp(actor, rect.x, rect.y, rect.width);
	    //this.drawActorMp(actor, rect.x + 216,  rect.y, 114);
	};
	
	// ウィンドウオープン
	var _Window_BattleStatus_open = 
		Window_BattleStatus.prototype.open;
	Window_BattleStatus.prototype.open = function() {
		_Window_BattleStatus_open.call(this);
		this.refresh();
	};
	
	// 上層レイヤーの作成
	var _Spriteset_Battle_createUpperLayer = Spriteset_Battle.prototype.createUpperLayer
	Spriteset_Battle.prototype.createUpperLayer = function() {
		this.createStatusWindow()
		_Spriteset_Battle_createUpperLayer.call(this);
	};

	// バトルステータスウィンドウの作成
	Spriteset_Battle.prototype.createStatusWindow = function () {
		this._statusWindow = new Window_BattleStatus();
		this._baseSprite.addChild(this._statusWindow);
	};

	// バトルステータスウィンドウ
	Spriteset_Battle.prototype.statusWindow = function () {
		return this._statusWindow;
	};

	// ダメージポップオフセットX
	Sprite_Actor.prototype.damageOffsetX = function() {
    	return 96;
	};
	
	// ダメージポップオフセットY
	Sprite_Actor.prototype.damageOffsetY = function() {
    	return -24;
	};

	// バトルステータスウィンドウの作成
	Scene_Battle.prototype.createStatusWindow = function () {
		this._statusWindow = this._spriteset.statusWindow();
	};

	// ウィンドウ位置の更新
	Scene_Battle.prototype.updateWindowPositions = function() {
	    var statusX = 0;
	    if (BattleManager.isInputting()) {
	        statusX = this._partyCommandWindow.width;
	    } else {
	        statusX = this._partyCommandWindow.width / 2;
	    }
	    if (this._statusWindow.x < statusX) {
	        this._statusWindow.x += 16;
	        if (this._statusWindow.x > statusX) {
	            this._statusWindow.x = statusX;
	        }
	    }
	    if (this._statusWindow.x > statusX) {
	        this._statusWindow.x -= 16;
	        if (this._statusWindow.x < statusX) {
	            this._statusWindow.x = statusX;
	        }
	    }
	    this._statusWindow.x = Graphics.boxWidth / 2 - 128;
	    this._statusWindow.y = Graphics.boxHeight - this._statusWindow.windowHeight() - 30;
//	    this._statusWindow.y = Graphics.boxHeight - this._statusWindow.windowHeight();
		$gameScreen.showPicture(99,"Shiki",1,408,490,100,100,255,0);
	};

	Window_BattleLog.prototype.messageSpeed = function() {
	    return 0;
	};

	// ランダム宝箱(アイテム)
	Game_Interpreter.prototype.prcItemGet = function(itemid, itemval)
	{
		 var value = this.operateValue(0, 0, itemval);
		 $gameParty.gainItem($dataItems[itemid], value);
		 var text = value == 1 ? ""+$dataItems[itemid].name+"を手に入れた！\\.\\.\\.\\^" : $dataItems[itemid].name+"を"+value+"個手に入れた！" ;
		 $gameMessage._positionType = 2;
		 $gameMessage.newPage();
		 $gameMessage.add(text);
	};

	// ランダム宝箱(武器)
	Game_Interpreter.prototype.prcWeaponGet = function(itemid, itemval)
	{
		 var value = this.operateValue(0, 0, itemval);
		 $gameParty.gainItem($dataWeapons[itemid], value);
		 var text = value == 1 ? ""+$dataWeapons[itemid].name+"を手に入れた！\\.\\.\\.\\^" : $dataWeapons[itemid].name+"を"+value+"個手に入れた！" ;
		 $gameMessage._positionType = 2;
		 $gameMessage.newPage();
		 $gameMessage.add(text);
	};

	// スキル空欄は表示しない
	var _Window_BattleLog_displayAction = 
	Window_BattleLog.prototype.displayAction;
	Window_BattleLog.prototype.displayAction = function(subject, item) {
			if(!(DataManager.isSkill(item) && item.id == subject.attackSkillId())) {
				if (item.name) {
				this.push('addItemNameText', item.name);
				}
			} else {
				this.push('wait');
			}
			return;
		_Window_BattleLog_displayAction.call(this, subject, item);
	};

	// 床ダメージの変更
	Game_Actor.prototype.basicFloorDamage = function() {
	    return 1;
	};

	// 入力方式の変更
	Window_NameInput.JAPAN2 =
	        [ 'ア','イ','ウ','エ','オ',  'ガ','ギ','グ','ゲ','ゴ',
	          'カ','キ','ク','ケ','コ',  'ザ','ジ','ズ','ゼ','ゾ',
	          'サ','シ','ス','セ','ソ',  'ダ','ヂ','ヅ','デ','ド',
	          'タ','チ','ツ','テ','ト',  'バ','ビ','ブ','ベ','ボ',
	          'ナ','ニ','ヌ','ネ','ノ',  'パ','ピ','プ','ペ','ポ',
	          'ハ','ヒ','フ','ヘ','ホ',  'ァ','ィ','ゥ','ェ','ォ',
	          'マ','ミ','ム','メ','モ',  'ッ','ャ','ュ','ョ','ヮ',
	          'ヤ','ユ','ヨ','ワ','ン',  'ー','～','・','＝','☆',
	          'ラ','リ','ル','レ','ロ',  'ヴ','ヲ','　','','決定' ];

	Window_NameInput.prototype.isPageChange = function() {
	    //return this._index === 88;
	};

	Window_NameEdit.prototype.left = function() {
	    var nameCenter = ((this.contentsWidth() + this.faceWidth()) / 2) - 40;
	    var nameWidth = (this._maxLength + 1) * this.charWidth();
	    return Math.min(nameCenter - nameWidth / 2, this.contentsWidth() - nameWidth);
	};
	Window_NameEdit.prototype.standardFontSize = function() {
	    return 28;
	};

	Window_NameInput.prototype.table = function() {
	    if ($gameSystem.isJapanese()) {
	        return [Window_NameInput.JAPAN2,
	                Window_NameInput.JAPAN1,
	                Window_NameInput.JAPAN3];
	    } else if ($gameSystem.isRussian()) {
	        return [Window_NameInput.RUSSIA];
	    } else {
	        return [Window_NameInput.LATIN1,
	                Window_NameInput.LATIN2];
	    }
	};

	// セーブ・ロード画面表示カスタマイズ
	DataManager.makeSavefileInfo = function() {
	    var info = {};
	    info.globalId   = this._globalId;
		info.title      = $dataSystem.gameTitle;
		info.mapname	= $gameMap.displayName();
	    info.characters = $gameParty.charactersForSavefile();
	    info.faces      = $gameParty.facesForSavefile();
	    info.playtime   = $gameSystem.playtimeText();
	    info.timestamp  = Date.now();
	    return info;
	};
	Window_SavefileList.prototype.drawGameMapName = function(info, x, y, width) {
	    if (info.mapname) {
	        this.drawText(info.mapname, x, y, width);
	    }
	};
	Window_SavefileList.prototype.maxVisibleItems = function() {
	    return 10;
	};
	Window_SavefileList.prototype.drawContents = function(info, rect, valid) {
	    var bottom = rect.y + rect.height;
	    if (rect.width >= 420) {
	        this.drawGameMapName(info, rect.x + 110, rect.y, rect.width - 192);
	        //this.drawGameTitle(info, rect.x + 192, rect.y, rect.width - 192);
	        //if (valid) {
	            //this.drawPartyCharacters(info, rect.x + 220, bottom - 4);
	        //}
	    }
//	    var lineHeight = this.lineHeight();
//	    var y2 = bottom - lineHeight;
//	    if (y2 >= lineHeight) {
	        this.drawPlaytime(info, rect.x + 190, rect.y, rect.width - 192);
//	    }
	};

	// 装備表示から攻撃力・防御力以外を削除
	Window_EquipStatus.prototype.refresh = function() {
    	this.contents.clear();
		if (this._actor) {
			this.drawActorName(this._actor, this.textPadding(), 0);
			for (var i = 0; i < 2; i++) {
				this.drawItem(-2, this.lineHeight() * (1 + i), 2 + i);
			}
		}
	};

	// ステータス表示から攻撃力・防御力以外を削除
	Window_Status.prototype.drawBasicInfo = function(x, y) {
	    var lineHeight = this.lineHeight();
	    this.drawActorLevel(this._actor, x, y + lineHeight * 0);
	    this.drawActorIcons(this._actor, x, y + lineHeight * 1);
	    this.drawActorHp(this._actor, x, y + lineHeight * 2);
	    this.drawActorTp(this._actor, x, y + lineHeight * 3);
	};
	Window_Base.prototype.drawActorTp = function(actor, x, y, width) {
	    width = width || 186;
	    var color1 = this.tpGaugeColor1();
	    var color2 = this.tpGaugeColor2();
	    this.drawGauge(x, y, width, actor.tpRate(), color1, color2);
	    this.changeTextColor(this.systemColor());
	    this.drawText(TextManager.tpA, x, y, 44);
	    this.changeTextColor(this.tpColor(actor));
	    this.drawText(actor.tp, x + width - 64, y, 64, 'right');
	};

	Window_Status.prototype.drawParameters = function(x, y) {
    var lineHeight = this.lineHeight();
    for (var i = 0; i < 2; i++) {
        var paramId = i + 2;
        var y2 = y + lineHeight * i;
        this.changeTextColor(this.systemColor());
        this.drawText(TextManager.param(paramId), x, y2, 160);
        this.resetTextColor();
        this.drawText(this._actor.param(paramId), x + 160, y2, 60, 'right');
    }
    	var ccresult = Math.floor(($gameVariables.value(45) / $gameVariables.value(44)) * 100);
		$gameVariables.setValue(48,ccresult);

        this.changeTextColor(this.systemColor());
        this.drawText("正解率", 49, 350, 160);
        this.resetTextColor();
        this.drawText($gameVariables.value(48)+" %", 206, 350, 60, 'right');

	};

	Scene_Map.prototype.updateMainMultiply = function() {
	    this.updateMain();
	    if (this.isFastForward() && !$gameSwitches.value(139)) {
	        this.updateMain();
	    }
	};

	// マップ名表示の文字サイズ
	Window_MapName.prototype.standardFontSize = function() {
	    return 20;
	};

	// マップ名表示のウィンドウ幅
	Window_MapName.prototype.windowWidth = function() {
	    return 400;
	};
	// フィールド上はマップ名表示しない
	// 黒背景表示しない
	Window_MapName.prototype.refresh = function() {
	    this.contents.clear();
	        var width = this.contentsWidth();
	        //this.drawBackground(0, 0, width, this.lineHeight());
	        this.drawText($gameMap.displayName(), 0, 0, width, 'left');
	};

	// バックログ背景を濃く
	Window_BattleLog.prototype.backPaintOpacity = function() {
	    return 196;
	};
	
	// クリティカルヒット時のタイムラグを除去
	Window_BattleLog.prototype.displayActionResults = function(subject, target) {
    if (target.result().used) {
        this.push('pushBaseLine');
        //this.displayCritical(target);
        this.push('popupDamage', target);
        this.push('popupDamage', subject);
        this.displayDamage(target);
        this.displayAffectedStatus(target);
        this.displayFailure(target);
        this.push('waitForNewLine');
        this.push('popBaseLine');
    }
	};

	
})();